REM    '(PROGRAMME TWIN)
       
REM    '-------------------------------
       DIM I AS BYTE
       DIM K AS BYTE
       DIM J AS INTEGER
       DIM BOUCLE AS BYTE
       DIM COMPTEUR AS BYTE
       DIM DROITE AS BYTE
       DIM GAUCHE AS BYTE
       DIM SEN(4)AS BYTE
       DIM MODE AS BYTE

REM   '--------------------------------
       CONST R_MOTOR = 9
       CONST L_MOTOR = 10
       CONST MOT_ON = 11
       CONST PIEZO_BUZZER = 8
       CONST START_BUTTON = 12
       CONST TRIGGER = 15

       CONST STOP = 128
       CONST FORWARD = 168
       CONST BACKWARD = 80
       
       CONST DISTANCE = 60     ' Distance de dtection des obstacles  
       CONST SEUIL = 10

       CONST TURN_TIME = 100
       CONST BACK_TIME = 100
  
       CONST SENSE_LEFT_OUT = 4
       CONST SENSE_LEFT_IN = 5
       CONST SENSE_RIGHT_IN = 6
       CONST SENSE_RIGHT_OUT =7

       CONST LED_LEFT = 13
       CONST LED_RIGHT = 14

REM    '--------------------------------

       POKE &H12,&H34        'NE PAS MODIFIER

       BEEP PIEZO_BUZZER
       PWM R_MOTOR,STOP
       PWM L_MOTOR,STOP
       OUT MOT_ON,1

WAIT:  IF KEYIN(START_BUTTON) = 1 THEN GOTO WAIT

       FOR K = 0 TO 3            
            OUT TRIGGER,1
            SEN(K) =ADIN(K) >> 2
            OUT TRIGGER,0
            DELAY 20
       NEXT K 
       
       IF SEN(0) > DISTANCE OR SEN(3) > DISTANCE THEN
       		   GOSUB MUSIC
               GOTO LOOP
       END IF   
       GOSUB MUSIC     

       
REM '------------- Robot chercheur d'IR ----------
       
LOOP1:    COMPTEUR = 0 
          DROITE = 0
          GAUCHE = 0
          FOR BOUCLE = 0 TO 20
        
            FOR K = 0 TO 3            
              SEN(K) =ADIN(K) >> 2
            NEXT K
       
            IF SEN(1) > SEUIL AND SEN(2) > SEUIL THEN
               COMPTEUR = COMPTEUR + 1
            END IF
            
            IF SEN(0) < SEUIL AND SEN(3) > SEUIL THEN
               DROITE = DROITE + 1
            ELSEIF SEN(0) > 1 AND SEN(3) < 1 THEN
               GAUCHE = GAUCHE + 1
            END IF    
            
            
           NEXT BOUCLE
           
           IF COMPTEUR > 0 THEN
           
               OUT LED_LEFT,1:OUT LED_RIGHT,1                           
               PWM R_MOTOR,FORWARD
               PWM L_MOTOR,FORWARD
               BEEP PIEZO_BUZZER
                
           ELSE   
               IF DROITE > 0 THEN
                  OUT LED_LEFT,1:OUT LED_RIGHT,0
                  PWM R_MOTOR,STOP
                  PWM L_MOTOR,FORWARD
               ELSE
                  OUT LED_LEFT,0:OUT LED_RIGHT,1
                  PWM R_MOTOR,FORWARD
                  PWM L_MOTOR,STOP
               END IF
               DELAY TURN_TIME
            END IF
                  
       GOTO LOOP1
       
       
       
       
       
REM '------------- Robot viteur d'obstacle ----------       
       
LOOP:  FOR K = 0 TO 3            
            OUT TRIGGER,1
            SEN(K) =ADIN(K) >> 2
            OUT TRIGGER,0
            DELAY 20
       NEXT K
       
REM '------------- Le Robot est dans un coin ----------
REM '------------- il fait alors demi-tours -----------
       
       IF SEN(0) > DISTANCE AND SEN(3) > DISTANCE THEN
               OUT LED_LEFT,1:OUT LED_RIGHT,1
               GOSUB U_TURN
       END IF        
             
        
REM '------------- Le Robot arrive droit sur un obstacle ----------
REM '---- il tourne pseudo alatoirement  droite ou  gauche -----
      IF SEN(1) > DISTANCE AND SEN(2) > DISTANCE THEN
               K=RND(0)
               IF K>128 THEN
                 OUT LED_LEFT,1:OUT LED_RIGHT,0
                 GOSUB RIGHT_TURN
               ELSE
                 OUT LED_LEFT,0:OUT LED_RIGHT,1
                 GOSUB LEFT_TURN
               END IF               
       END IF         
    
        
REM '------------- Le Robot a un obstacle  droite ou  gauche ----------
REM '-------------------- il tourne en consquence ----------------------

       IF SEN(0) > DISTANCE AND SEN(3) < DISTANCE THEN
               OUT LED_LEFT,1:OUT LED_RIGHT,0
               GOSUB RIGHT_TURN
       ELSEIF SEN(0) < DISTANCE AND SEN(3) > DISTANCE THEN
               OUT LED_LEFT,0:OUT LED_RIGHT,1
               GOSUB LEFT_TURN
       ELSE
               OUT LED_LEFT,0:OUT LED_RIGHT,0
               PWM L_MOTOR,FORWARD
               PWM R_MOTOR,FORWARD
       END IF
       GOTO LOOP

REM   '------------------------------

LEFT_TURN:
      PWM R_MOTOR,FORWARD
      PWM L_MOTOR,STOP
      DELAY TURN_TIME
      BEEP PIEZO_BUZZER
      RETURN

RIGHT_TURN:
      PWM R_MOTOR,STOP
      PWM L_MOTOR,FORWARD
      DELAY TURN_TIME
      BEEP PIEZO_BUZZER
      RETURN

U_TURN:
      GOSUB BACK
      PWM R_MOTOR,BACKWARD
      PWM L_MOTOR,FORWARD
      DELAY TURN_TIME
      DELAY TURN_TIME
      GOSUB MOTOR_STOP
      RETURN

MOTOR_STOP:
      PWM R_MOTOR,STOP
      PWM L_MOTOR,STOP
      BEEP PIEZO_BUZZER
      RETURN
      
BACK: PWM R_MOTOR,BACKWARD
      PWM L_MOTOR,BACKWARD
      DELAY BACK_TIME
      GOSUB MOTOR_STOP
      RETURN
      
MUSIC: SOUND PIEZO_BUZZER,80,8:DELAY 500
       SOUND PIEZO_BUZZER,80,8:DELAY 500
       SOUND PIEZO_BUZZER,60,15
       RETURN    