REM    '(PROGRAMME Robot Vagabond Eddy)
       
REM    '-------------------------------
       DIM I AS BYTE
       DIM J AS INTEGER
       DIM S0 AS BYTE
       DIM S1 AS BYTE
       DIM S2 AS BYTE
       DIM S3 AS BYTE
       DIM MODE AS BYTE

REM   '--------------------------------
       CONST R_MOTOR = 9
       CONST L_MOTOR = 10
       CONST MOT_ON = 11
       CONST PIEZO_BUZZER = 8
       CONST START_BUTTON = 12

       CONST STOP = 128
       CONST FORWARD = 158
       CONST BACKWARD = 78

       CONST TURN_TIME = 250
       CONST BACK_TIME = 200

       CONST SENSE_LEFT_OUT = 4
       CONST SENSE_LEFT_IN = 5
       CONST SENSE_RIGHT_IN = 6
       CONST SENSE_RIGHT_OUT =7

       CONST LED_LEFT = 13
       CONST LED_RIGHT = 14

REM    '--------------------------------

       POKE &H12,&H34        'NE PAS MODIFIER

       BEEP PIEZO_BUZZER
       PWM R_MOTOR,STOP
       PWM L_MOTOR,STOP
       OUT MOT_ON,1

WAIT:  IF KEYIN(START_BUTTON) = 1 THEN GOTO WAIT

       SOUND PIEZO_BUZZER,80,8:DELAY 500
       SOUND PIEZO_BUZZER,80,8:DELAY 500
       SOUND PIEZO_BUZZER,60,15

LOOP:  S0 = IN(SENSE_LEFT_OUT)
       S1 = IN(SENSE_LEFT_IN)
       S2 = IN(SENSE_RIGHT_IN)
       S3 = IN(SENSE_RIGHT_OUT)
       IF S0 = 0 AND S3 = 1 THEN
               OUT LED_LEFT,1:OUT LED_RIGHT,0
               GOSUB RIGHT_TURN
       ELSEIF S0 = 1 AND S3 = 0 THEN
               OUT LED_LEFT,0:OUT LED_RIGHT,1
               GOSUB LEFT_TURN
       ELSEIF S1 = 0 OR S2 = 0 THEN
               OUT LED_LEFT,1:OUT LED_RIGHT,1
               GOSUB U_TURN
       ELSE
               OUT LED_LEFT,0:OUT LED_RIGHT,0
               PWM L_MOTOR,FORWARD
               PWM R_MOTOR,FORWARD
       END IF
       GOTO LOOP

REM   '------------------------------

LEFT_TURN:
      GOSUB BACK
      PWM R_MOTOR,FORWARD
      PWM L_MOTOR,BACKWARD
      DELAY TURN_TIME
      GOSUB MOTOR_STOP
      RETURN

RIGHT_TURN:
      GOSUB BACK
      PWM R_MOTOR,BACKWARD
      PWM L_MOTOR,FORWARD
      DELAY TURN_TIME
      GOSUB MOTOR_STOP
      RETURN

U_TURN:
      GOSUB BACK
      PWM R_MOTOR,BACKWARD
      PWM L_MOTOR,FORWARD
      DELAY TURN_TIME
      DELAY TURN_TIME
      GOSUB MOTOR_STOP
      RETURN

MOTOR_STOP:
      PWM R_MOTOR,STOP
      PWM L_MOTOR,STOP
      BEEP PIEZO_BUZZER
      RETURN
BACK: PWM R_MOTOR,BACKWARD
PWM L_MOTOR,BACKWARD
DELAY BACK_TIME
GOSUB MOTOR_STOP
RETURN
